
//Se definen las variables
var JwtStrategy = require('passport-jwt').Strategy;
var ExtractJwt = require('passport-jwt').ExtractJwt;
var User = require('../models/user');
var config = require('../config/database');

// Utiliza el json web token para generar un ingreso por medio de pasaporte a los usuarios
module.exports = function(passport) {
     var  opts = {};
    opts.secretOrKey =  config.secret; //Obtiene el secreto del archivo database.js
    opts.jwtFromRequest = ExtractJwt.fromAuthHeader();
    passport.use(new JwtStrategy(opts, function(jwt_payload, done){
        User.find({id: jwt_payload.id}, function(err, user){//el payload es la información a desencriptar
            if (err) {
                return done(err, false);
            }
            if (user) {
                return done(null, user);
            } else {
                return done(null, false);
            }
        })
    }));
}