
//se definen las variables
var Planta = require('../models/planta');
var Sensor = require('../models/sensor');
var User = require('../models/user');
var Dato_Sensor = require('../models/dato_sensor');
var Planta_Personal = require('../models/planta_personal');
var Familia = require('../models/familia');
var Enfermedad = require('../models/enfermedad');
var Sintoma = require('../models/sintoma');
var Condicion_Climatica = require('../models/condicion_climatica');
var Vegetacion = require('../models/vegetacion');

var config = require('../config/database');
var jwt = require('jwt-simple'); //json web token para autenticación simple
//Se definen las funciones de añadir, autenticar y obtener información de los tokens.


///Plataforma IoT thingspeak
var ThingSpeakClient = require('thingspeakclient');
var client = new ThingSpeakClient({ server: 'https://api.thingspeak.com' });
client.attachChannel(169278, { writeKey: 'ZFIZC3X3OZ08N0M4', readKey: 'UJ5JNQ3BUJ6OFPZD' }, function (err, res) {
    if (err) {
        console.log('error');
    }
});
///


var functions = {
    //La función de autenticación
    authenticate: function (req, res) {
        User.findOne({
            name: req.body.name
        }, function (err, user) {
            if (err) throw err;//lanza un error

            //Si no encuentra el usuario envia un mensaje
            if (!user) {
                res.json({ success: false, msg: 'Falló la autenticación, el usuario no se encontró' });
            }

            else {
                user.comparePassword(req.body.password, function (err, isMatch) {
                    if (isMatch && !err) {
                        //autentica correctamente
                        var token = jwt.encode(user, config.secret);
                        res.json({ success: true, token: token });
                    } else {
                        //si el usuario existe pero hay un error o algo, envía un mensaje sobre la contraseña
                        return res.json({ success: false, msg: 'Falló la autenticación, posible ingreso de contraseña incorrecta' });
                    }
                })
            }

        })
    },
    //La función de añadir un usuario
    addNew: function (req, res) {//Listo
        //si no encuentra los campos requeridos completados envia un mensaje

        if ((!req.body.name) || (!req.body.password)) {
            res.json({ success: false, msg: 'Ingrese todos los campos requeridos (*)' });
        }
        else {
            //sino entonces asigna las variables a la request que le llegue            
            var newUser = User({
                _cedula: req.body._cedula,
                name: req.body.name,
                password: req.body.password,
                nombre1: req.body.nombre1,
                nombre2: req.body.nombre2,
                apellido1: req.body.apellido1,
                apellido2: req.body.apellido2,
                phone: req.body.phone,
                email: req.body.email
            });
            console.log('{' + newUser + '}');
            User.find({ name: req.body.name }, function (err, docs) {
                if (docs.length) {
                    res.json({ success: false, msg: 'Error, ya existe el usuario' })
                } else {
                    //Trata de guardar el usuario
                    newUser.save(function (err, newUser) {
                        if (err) {
                            res.json({ success: false, msg: 'Error al guardar' })
                        }
                        else {
                            res.json({ success: true, msg: 'Guardado correctamente' });
                        }
                    })
                }
            });
        }

    },
    addPlantaPersonal: function (req, res) {//Listo

        if ((!req.body.posicion_planta)) {
            res.json({ success: false, msg: 'Ingrese todos los campos requeridos (*)' });
        }
        else {            
            //verifica que el usuario existe
            User.findOne({ '_cedula': req.body.idUser }, function (err, user) {
                
                if (err) {
                    res.json({ success: false, msg: 'Error desconocido, el usuario no existe' });
                    return handleError(err);
                }
                else {
                    if (user != null) {
                        var ud = user._cedula;
                        console.log(ud);
                        //verifica que la planta existe
                        Planta.findOne({ 'id_planta': req.body.idPlanta }, function (err, planta) {
                            if (err) {
                                res.json({ success: false, msg: 'Error desconocido, la planta no existe' });
                                return handleError(err);
                            }
                            else {
                                if (planta != null) {
                                    //asigna las variables de la planta
                                    var pd = planta.id_planta;
                                    var planta = new Planta_Personal({
                                        posicion_planta: req.body.posicion_planta,
                                        idUser: ud,
                                        idPlanta: pd
                                    });
                                    Planta_Personal.find({ 'posicion_planta': req.body.posicion_planta, 'idUser': ud }, function (req, docs) {
                                        if (docs.length) {
                                            res.json({ sucess: false, msg: 'verifica la posición' });
                                        }
                                        else {
                                            //guarda la planta peronal en la colección
                                            planta.save(function (err, newPlant) {
                                                if (err) {
                                                    res.json({ success: false, msg: "Error al guardar, el usuario o la planta no existen, verifica las Id's " })
                                                }
                                                else {
                                                    res.json({
                                                        success: true, msg: 'True', posicion_planta: planta.posicion_planta, id_Planta: planta._id,
                                                    });
                                                }
                                            });
                                        }
                                    });
                                }
                                else {
                                    res.json({ success: false, msg: 'La planta no existe' });
                                }
                            }
                        });
                    }
                    else {
                        res.json({ success: false, msg: 'El usuario no existe' });
                    }
                }
            });

        }
    },
    addPlanta: function (req, res) {//Listo
        //si no encuentra los campos requeridos completados envia un mensaje
        if ((!req.body.nombre) || (!req.body.id_planta)) {
            console.log(req.body.nombre);

            res.json({ success: false, msg: 'Ingrese todos los campos requeridos (*)' });
        }
        else {
            //sino entonces asigna las variables a la request que le llegue

            Familia.findOne({ 'codigo_familia': req.body.idFamilia }, function (err, familia) {
                if (err) {
                    res.json({ success: false, msg: 'Error desconocido, la familia no existe no existe' });
                    return handleError(err);
                }
                else {
                    if (familia != null) {
                        var idFam = familia.codigo_familia
                        var newPlant = Planta({
                            id_planta: req.body.id_planta,
                            nombre: req.body.nombre,
                            nombreCient: req.body.nombreCient,
                            tamano: req.body.tamaño,
                            idFamilia: idFam
                        });

                        Planta.find({ 'id_planta': req.body.id_planta }, function (err, docs) {

                            if (docs.length) {
                                res.json({ success: false, msg: 'Ya existe una planta con ése id' });
                            }
                            else {
                                //Trata de guardar el usuario
                                newPlant.save(function (err, newPlant) {
                                    if (err) {
                                        res.json({ success: false, msg: 'Error al guardar' })
                                    }

                                    else {
                                        res.json({ success: true, msg: 'Guardado correctamente' });
                                    }

                                });
                            }
                        });


                    }
                    else {
                        res.json({ success: false, msg: 'La familia no existe' });
                    }
                }
            });
        }
    },
    addSensor: function (req, res) {//Listo
        //si no encuentra los campos requeridos completados envia un mensaje
        if ((!req.body.nombre) || (!req.body.codigo_sensor)) {
            console.log(req.body.nombre);

            res.json({ success: false, msg: 'Ingrese todos los campos requeridos (*)' });
        }
        else {
            Sensor.find({ 'codigo_sensor': req.body.codigo_sensor }, function (err, docs) {
                if (docs.length) {
                    res.json({ sucess: false, msg: 'Ya existe un sensor con ése id' });
                }
                else {
                    //verifica que la planta exista
                    Planta_Personal.findOne({ 'posicion_planta': req.body.posicion_planta }, function (err, planta_p) {
                        if (err) {
                            res.json({ success: false, msg: 'Error desconocido, la planta no existe no existe' });
                            return handleError(err);
                        }
                        else {

                            if (planta_p != null) {

                                User.findOne({ '_cedula': req.body.idUser }, function (err, user) {
                                    if (err) {
                                        res.json({ success: false, msg: 'Error desconocido, la planta no existe no existe' });
                                        return handleError(err);
                                    }
                                    else {
                                        if (user != null) {
                                            var idP_P = planta_p.posicion_planta;

                                            var newSens = Sensor({
                                                codigo_sensor: req.body.codigo_sensor,
                                                nombre: req.body.nombre,
                                                idPlanta_Personal: user._cedula + idP_P
                                            });
                                            //Trata de guardar el sensor
                                            newSens.save(function (err, newSens) {
                                                if (err) {
                                                    res.json({ success: false, msg: 'Error al guardar' })
                                                }
                                                else {
                                                    res.json({ success: true, msg: 'Guardado correctamente del usuario: ' + user._cedula });
                                                }
                                            })
                                        }
                                        else {
                                            res.json({ success: false, msg: 'El usuario no existe' });
                                        }
                                    }
                                });
                            }
                            else {
                                res.json({ success: false, msg: 'La planta personal no existe' });
                            }
                        }
                    });
                }
            })

        }
    },
    addDatoSensor: function (req, res) {//Listo
        //si no encuentra los campos requeridos completados envia un mensaje
        if ((!req.body.informacion)) {
            res.json({ success: false, msg: 'Ingrese todos los campos requeridos (*)' });
        }
        else {
            //sino entonces asigna las variables a la request que le llegue

            //verifica que la planta exista
            Sensor.findOne({ 'codigo_sensor': req.body.codigo_sensor }, function (err, sensor) {
            console.log(req.body.codigo_sensor);
                if (err) {
                    res.json({ success: false, msg: 'Error desconocido, el sensor no existe no existe no existe' });
                    return handleError(err);
                }
                else {

                    if (sensor != null) {
                        var idSensor = sensor.codigo_sensor;

                        var newDataSens = Dato_Sensor({
                            informacion: req.body.informacion,
                            fecha_hora: new Date,
                            idSensor: idSensor
                        });
                        //Trata de guardar el sensor
                        newDataSens.save(function (err, newSens) {
                            if (err) {
                                res.json({ success: false, msg: 'Error al guardar' })
                            }

                            else {
                                res.json({ success: true, msg: 'Guardado correctamente' });
                                postOnIoT(1, newDataSens.informacion);
                            }
                        });

                    }
                    else {
                        res.json({ success: false, msg: 'El sensor no existe' });
                    }
                }
            });
        }
    },
    addFamilia: function (req, res) {//Listo
        if ((!req.body.nombre) || (!req.body.codigo_familia)) {
            console.log(req.body.nombre);

            res.json({ success: false, msg: 'Ingrese todos los campos requeridos (*)' });
        }
        else {
            var newFam = Familia({
                codigo_familia: req.body.codigo_familia,
                nombre: req.body.nombre,
                nombre_cientifico: req.body.nombre_cientifico
            });

            Familia.find({ 'codigo_familia': req.body.codigo_familia }, function (err, docs) {
                if (docs.length) {
                    res.json({ success: false, msg: 'Ya existe una familia con ése id' });
                }
                else {
                    //Trata de guardar el usuario
                    newFam.save(function (err, newFam) {
                        if (err) {
                            res.json({ success: false, msg: 'Error al guardar' })
                        }

                        else {
                            res.json({ success: true, msg: 'Guardado correctamente' });
                        }

                    });
                }

            });

        }
    },
    addEnfermedad: function (req, res) {//Listo
        if ((!req.body.nombre) || (!req.body.id_Enfermedad)) {
            console.log(req.body.nombre);

            res.json({ success: false, msg: 'Ingrese todos los campos requeridos (*)' });
        }
        else {
            var newEnf = Enfermedad({
                id_Enfermedad: req.body.id_Enfermedad,
                nombre: req.body.nombre,
            });

            Enfermedad.find({ 'id_Enfermedad': req.body.id_Enfermedad }, function (err, docs) {
                if (docs.length) {
                    res.json({ success: false, msg: 'La id de enfermedad ya existe' });
                }
                else {
                    //Trata de guardar el usuario
                    newEnf.save(function (err, newFam) {
                        if (err) {
                            res.json({ success: false, msg: 'Error al guardar' })
                        }
                        else {
                            res.json({ success: true, msg: 'Guardado correctamente' });
                        }
                    });
                }
            });


        }
    },
    addSintoma: function (req, res) {//Listo

        if ((!req.body.nombre) || (!req.body.id_sintoma)) {
            res.json({ success: false, msg: 'Ingrese todos los campos requeridos (*)' });
        }
        else {
            //sino entonces asigna las variables a la request que le llegue

            //verifica que el usuario existe
            Enfermedad.findOne({ 'id_Enfermedad': req.body.idEnfermedad }, function (err, enfermedad) {
                if (err) {
                    res.json({ success: false, msg: 'Error desconocido, la enfermedad no existe' });
                    return handleError(err);
                }
                else {
                    if (enfermedad != null) {
                        var ed = enfermedad.id_Enfermedad;

                        //verifica que la planta existe
                        Planta.findOne({ 'id_planta': req.body.idPlanta }, function (err, planta) {
                            if (err) {
                                res.json({ success: false, msg: 'Error desconocido, la planta no existe' });
                                return handleError(err);
                            }
                            else {
                                if (planta != null) {
                                    //asigna las variables de la planta
                                    var pd = planta.id_planta;
                                    var newSint = new Sintoma({
                                        _idSintoma: req.body._idEnfermedad,
                                        id_sintoma: req.body.id_sintoma,
                                        nombre: req.body.nombre,
                                        descripcion: req.body.descripcion,
                                        idPlanta: pd,
                                        idEnfermedad: ed

                                    });
                                    Sintoma.find({'id_sintoma':req.body.id_sintoma}, function(err, docs){
                                    if(docs.length){
                                        res.json({success:false, msg:'Ya existe un id con ése síntoma'});
                                    }
                                    else{
                                        //guarda la planta peronal en la colección
                                    newSint.save(function (err, newSint) {
                                        if (err) {
                                            res.json({ success: false, msg: "Error al guardar, la enfermedad o la planta no existen, verifica las Id's " })
                                        }
                                        else { res.json({ success: true, msg: 'True' }) }
                                    });
                                    }
                                    });
                                    
                                }
                                else{
                                    res.json({ success: false, msg: 'La planta no existe' });
                                }
                            }
                        });
                    }
                    else {
                        res.json({ success: false, msg: 'La enfermedad no existe' });
                    }
                }
            });

        }
    },
    addCondicionClimatica: function (req, res) {//Listo
        if ((!req.body.temperatura || !req.body.humedad || !req.body.humedad_relativa || !req.body.id_condicion)) {
            console.log(req.body.nombre);

            res.json({ success: false, msg: 'Ingrese todos los campos requeridos (*)' });
        }
        else {

            var newCond_c = Condicion_Climatica({
                id_condicion: req.body.id_condicion,
                temperatura: req.body.temperatura,
                humedad: req.body.humedad,
                humedad_relativa: req.body.humedad_relativa
            });

            Condicion_Climatica.find({ 'id_condicion': req.body.id_condicion}, function (err, docs) {
                if (docs.length) {
                    res.json({ success: false, msg: 'Ya existe una condicion climatica con ése id' });
                }
                else {
                    //Trata de guardar el usuario
                    newCond_c.save(function (err, newCond_c) {
                        if (err) {
                            res.json({ success: false, msg: 'Error al guardar' })
                        }

                        else {
                            res.json({ success: true, msg: 'Guardado correctamente' });
                        }

                    });
                }
            });


        }
    },
    addVegetacion: function (req, res) {//Listo
        if ((!req.body.beneficios) || (!req.body.id_vegetacion)) {
            res.json({ success: false, msg: 'Ingrese todos los campos requeridos (*)' });
        }
        else {
            //sino entonces asigna las variables a la request que le llegue

            //verifica que el usuario existe
            Condicion_Climatica.findOne({ 'id_condicion': req.body.idcondicionClimatica }, function (err, cond_c) {
                if (err) {
                    res.json({ success: false, msg: 'Error desconocido, la planta no existe' });
                    return handleError(err);
                }
                else {
                    if (cond_c != null) {
                        var cd = cond_c.id_condicion;

                        //verifica que la planta existe
                        Planta.findOne({ 'id_planta': req.body.idPlanta }, function (err, planta) {
                            if (err) {
                                res.json({ success: false, msg: 'Error desconocido, la planta no existe' });
                                return handleError(err);
                            }
                            else {
                                if (planta != null) {
                                    //asigna las variables de la planta
                                    var pd = planta.id_planta;
                                    var vegetacion = new Vegetacion({
                                        id_vegetacion: req.body.id_vegetacion,
                                        beneficios: req.body.beneficios,
                                        idPlanta: pd,
                                        idCondicionClimatica: cd
                                    });
                                    //guarda la planta peronal en la colección
                                    vegetacion.save(function (err, newPlant) {
                                        if (err) {

                                            res.json({ success: false, msg: "Error al guardar, la condicion climática o la planta no existen, verifica las Id's " })
                                        }
                                        else { res.json({ success: true, msg: 'True' }) }
                                    });
                                }
                                else{
                                    res.json({success:false, msg:'la planta no existe'});
                                }
                            }
                        });
                    }
                    else {
                        res.json({ success: false, msg: 'La condicion climática no existe' });
                    }
                }
            });

        }
    },
    addSensorSolo: function (req, res) {
        User.findOne({ '_cedula': req.body.idUser }, function (err, user) {
            if (err) {
                res.json({ success: false, msg: 'Error desconocido, la planta no existe no existe' });
                return handleError(err);
            }
            else {
                if (user != null) {

                    var newSens = Sensor({
                        codigo_sensor: req.body.codigo_sensor,
                        nombre: req.body.nombre,
                        idPlanta_Personal: user._cedula
                    });
                    //Trata de guardar el sensor
                    Sensor.find({ 'codigo_sensor': req.body.codigo_sensor }, function (err, docs) {
                        if (docs.length) {
                            res.json({ success: false, msg: 'Ya existe un sensor con ése id' })

                        }
                        else {
                            newSens.save(function (err, newSens) {
                                if (err) {
                                    res.json({ success: false, msg: 'Error al guardar' })
                                }
                                else {
                                    res.json({ success: true, msg: 'Guardado correctamente del usuario: ' + user._cedula });
                                }
                            })
                        }
                    })

                }
                else {
                    res.json({ success: false, msg: 'El usuario no existe' });
                }
            }
        });
    }


}
//Postea la información en ThingSpeak para su posterior análisis
function postOnIoT(field, data) {
    //Postea la información del sensor en la nube ! :D
    switch (field) {
        case 0:
        client.updateChannel(169278, { field5: data }, function (err, resp) {
                if (!err && resp > 0) {
                    console.log('Se han actualizado correctamente ' + resp + ' datos');
                }
            });
        break;
        case 1:
            client.updateChannel(169278, { field1: data }, function (err, resp) {
                if (!err && resp > 0) {
                    console.log('Se han actualizado correctamente ' + resp + ' datos');
                }
            });
            break;
        case 2:
            client.updateChannel(169278, { field2: data }, function (err, resp) {
                if (!err && resp > 0) {
                    console.log('Se han actualizado correctamente ' + resp + ' datos');
                }
            });
            break;
        case 3:
            client.updateChannel(169278, { field3: data }, function (err, resp) {
                if (!err && resp > 0) {
                    console.log('Se han actualizado correctamente ' + resp + ' datos');
                }
            });
            break;
        case 4:
        client.updateChannel(169278, { field4: data }, function (err, resp) {
                if (!err && resp > 0) {
                    console.log('Se han actualizado correctamente ' + resp + ' datos');
                }
            });
            break;
    }


}

module.exports = functions;