
//se definen las variables
var Planta = require('../models/planta');
var Sensor = require('../models/sensor');
var User = require('../models/user');
var Dato_Sensor = require('../models/dato_sensor');
var Planta_Personal = require('../models/planta_personal');
var Familia = require('../models/familia');
var Enfermedad = require('../models/enfermedad');
var Sintoma = require('../models/sintoma');
var Condicion_Climatica = require('../models/condicion_climatica');
var Vegetacion = require('../models/vegetacion');

var config = require('../config/database');
var jwt = require('jwt-simple');

var query = {
    //La función de obtener información del usuario
    getinfo: function (req, res) {
        if (req.headers.authorization && req.headers.authorization.split(' ')[0] === 'Bearer') {
            var token = req.headers.authorization.split(' ')[1];
            var decodedtoken = jwt.decode(token, config.secret);
            return res.json({ success: true, msg: 'Bienvenido ' + decodedtoken.name + 'Teléfono: ' + decodedtoken.phone + 
            'Email: ' + decodedtoken.email + 'Cedula: ' + decodedtoken._cedula, cedula:decodedtoken._cedula });
        }//ggg
        else {
            return res.json({ success: false, msg: 'No header' });
        }
    },
    showUser: function (req, res) {//Listo
        
        var query = User.findOne({ '_cedula' : req.body._cedula });
        
        query.select('_id _cedula name nombre1 nombre2 apellido1 apellido2 phone email');
        query.exec(function (err, user) {
            if (user == null) {
                res.json({ success: false, msg: 'No se encontró el usuario' });
            }
            else {
                if (err) { res.json({ success: false, msg: 'no se pudo encontrar el usuario' }); return handleError(err); }
                else {
                    res.json({
                        success: true, msg: "usuario encontrado con id: '"+ user._cedula + "'"
                        +" nickname: " + "'" + user.name + "'" + " nombre completo: " + "'" 
                        + user.nombre1 + " "+ user.nombre2 +" "+ user.apellido1 +" "+user.apellido2 + "'"
                        + "telefono: '"+user.phone+"'"+" correo: '"+ "'"+ user.email+"'"

                    });
                }
            }
        });
    },
    showPlantaPersonal: function (req, res) {//Listo
        
        var query = Planta_Personal.findOne({ 'posicion_planta': req.query.posicion_planta, 'idUser':req.query._cedula  });
        query.select('_id posicion_planta idUser idPlanta');
        query.exec(function (err, planta_p) {
            if (planta_p == null) {
                res.json({ success: false, msg: 'No se encontró la planta personal' });
            }
            if (err) { res.json({ success: false, msg: 'no se pudo encontrar la planta' }); }
            else {
                User.findOne({ '_cedula':  planta_p.idUser}, function (err, user) {
                    if (err) { res.json({ success: false, msg: 'no se pudo encontrar el usuario' }); }
                    else {
                        Planta.findOne({ 'id_planta': planta_p.idPlanta }, function (err, planta) {
                            if (planta == null) { res.json({ success: false, msg: 'no se pudo encontrar la planta' }); }
                            else if (err) {
                                return handleError(err);
                            }
                            else {
                                Sensor.findOne({ 'idPlanta_Personal': planta_p.idUser+planta_p.posicion_planta }, function (err, sensors) {
                                    console.log(planta_p.idUser+planta_p.posicion_planta);
                                    if (sensors == null) { res.json({ success: false, msg: 'no se pudo encontrar el sensor' }); }
                                    else if (err) {
                                        return handleError(err);
                                    }
                                    else {
                                        /*var query = Dato_Sensor.findOne({ 'idSensor': sensors.codigo_sensor });
                                        query.select('_id informacion fecha_hora idSensor').sort('-fecha_hora');
                                        query.exec(function (err, dato_s1) {
                                            if (dato_s1 == null) { res.json({ success: false, msg: 'no se pudo encontrar la dato' }); }
                                            else if (err) {
                                                return handleError(err);
                                            }
                                            else {*/
                                                         res.json({
                                                    success: true, msg: 'Se encontró la planta con el id: ' + planta_p.posicion_planta
                                                    + 'Del usuario ' + planta_p.idUser + ' Con un sensor ' + sensors.codigo_sensor+
                                                    ' con un dato ',
                                                    posicion_planta:planta_p.posicion_planta,
                                                    idUser:planta_p.idUser,
                                                    codigo_sensor:sensors.codigo_sensor,
                                                    nombre_s: sensors.nombre,
                                                    //info_s1: dato_s1.informacion,
                                                    nombre_p: planta.nombre,
                                                    nombre_c_p:planta.nombreCient,
                                                    
                                                });
                                            /*   
                                            }
                                        });*/
                                    }
                                });
                            }
                        });
                    }
                });
            }

        });
    },
    
    showPlanta: function (req, res) {//Listo
        var query = Planta.findOne({ 'id_planta': req.query.id_planta });
        console.log(req.query.id_planta);
        query.select('_id id_planta nombre idFamilia nombreCient');
        query.exec(function (err, planta) {
            if (planta == null) {
                res.json({ success: false, msg: 'No se encontró la planta' });
            }
            else {
                if (err) { res.json({ success: false, msg: 'no se pudo encontrar la planta' }); return handleError(err); }
                else {
                    var query = Familia.findOne({ 'codigo_familia': planta.idFamilia });
                    query.select('_id codigo_familia nombre nombre_cientifico');
                    query.exec(function (err, familia) {
                        if (familia == null) {
                            res.json({ success: false, msg: 'No se encontró la familia' });
                        }
                        else {
                            if (err) { res.json({ success: false, msg: 'no se pudo encontrar la familia' }); return handleError(err); }
                            else {
                                var query = Sintoma.findOne({ 'idPlanta': planta.id_planta });
                                query.select('_id idPlanta idEnfermedad nombre descripcion nombreCient');
                                query.exec(function (err, sintoma) {
                                    if (sintoma == null) {
                                        res.json({ success: false, msg: 'No se encontró el sintoma' });
                                    }
                                    else {
                                        if (err) { res.json({ success: false, msg: 'no se pudo encontrar el sintoma' }); return handleError(err); }
                                        else {
                                            var query = Enfermedad.findOne({ 'id_Enfermedad': sintoma.idEnfermedad });
                                            query.select('_id id_planta nombre id_Enfermeda');
                                            query.exec(function (err, enfermedad) {
                                                if (enfermedad == null) {
                                                    res.json({ success: false, msg: 'No se encontró la enfermedad' });
                                                }
                                                else {
                                                    if (err) { res.json({ success: false, msg: 'no se pudo encontrar la enfermedad' }); return handleError(err); }
                                                    else {
                                                        var query = Vegetacion.findOne({ 'idPlanta': planta.id_planta });
                                                        query.select('_id id_vegetacion beneficios idPlanta idCondicionClimatica');
                                                        query.exec(function (err, veget) {
                                                            if (veget == null) {
                                                                res.json({ success: false, msg: 'No se encontró la Vegetacion' });
                                                            }
                                                            else {
                                                                if (err) { res.json({ success: false, msg: 'no se pudo encontrar la veget' }); return handleError(err); }
                                                                else {
                                                                    var query = Condicion_Climatica.findOne({ 'id_condicion': veget.idCondicionClimatica });
                                                                    query.select('_id id_planta nombre idFamilia id_condicion humedad temperatura humedad_relativa');
                                                                    query.exec(function (err, cond_c) {
                                                                        if (cond_c == null) {
                                                                            res.json({ success: false, msg: 'No se encontró la condicion' });
                                                                        }
                                                                        else {
                                                                            if (err) { res.json({ success: false, msg: 'no se pudo encontrar la condicion' }); return handleError(err); }
                                                                            else {
                                                                                res.json({
                                                                                    success: true, msg: "Planta encontrada con id: '" + planta.id_planta + "'" +
                                                                                    " nombre: '" + planta.nombre + "'" + " perteneciente a la familia con id '" + planta.idFamilia,
                                                                                    id_planta: planta.id_planta,
                                                                                    id_condicion: cond_c.id_condicion,
                                                                                    id_vegetacion: veget.id_vegetacion,
                                                                                    id_Enfermedad: enfermedad.id_Enfermedad,
                                                                                    codigo_familia: familia.codigo_familia,
                                                                                    nombre_c: planta.nombre,
                                                                                    nombre_c_p : planta.nombreCient,
                                                                                    nombre_e: enfermedad.nombre,
                                                                                    nombre_s: sintoma.nombre,
                                                                                    descripcion_s: sintoma.descripcion,
                                                                                    nombre_f: familia.nombre,
                                                                                    nombre_f_c: familia.nombre_cientifico,
                                                                                    cond_t: cond_c.temperatura,
                                                                                    cond_h: cond_c.humedad,
                                                                                    cond_h_r: cond_c.humedad_relativa                                                                               });
                                                                            }
                                                                        }
                                                                    });
                                                                }
                                                            }
                                                        });
                                                    }
                                                }
                                            });
                                        }
                                    }
                                });
                            }
                        }
                    });
                }
            }
        });

    },
    showSensor: function (req, res) {//Listo
        var query = Sensor.findOne({ 'codigo_sensor': req.body.codigo_sensor });
        query.select('_id codigo_sensor nombre idPlanta_Personal');
        query.exec(function (err, sensor) {
            if (sensor == null) {
                res.json({ success: false, msg: 'No se encontró el sensor' });
            }
            else {
                if (err) { res.json({ success: false, msg: 'no se pudo encontrar el sensor' }); return handleError(err); }
                else {
                    res.json({
                        success: true, msg: "Sensor encontrado con id: '" + sensor.codigo_sensor + "'" +
                        " nombre: '" + sensor.nombre + "'" + " Asignado a la planta con id: '" + sensor.idPlanta_Personal
                        + "'"
                    });
                }
            }
        });

    },
    showDato_Sensor: function (req, res) {//Listo
        var query = Dato_Sensor.findOne({ 'idSensor': req.query.idSensor});
        query.select('_id informacion fecha_hora idSensor').sort('-fecha_hora');
        query.exec(function (err, dato_sensor) {
            if (dato_sensor == null) {
                res.json({ success: false, msg: 'No se encontró el dato' });
            } else {
                if (err) { res.json({ success: false, msg: 'no se pudo encontrar el dato del sensor' }); return handleError(err); }
                else {
                    console.log("informacion sensor " + dato_sensor.informacion);
                    res.json({
                        success: true, msg: "Dato de sensor encontrado con id: '" + dato_sensor.codigo_dato + "'" +
                        " informacion: '" + dato_sensor.informacion + "'" + " Perteneciente al sensor con id: '" + dato_sensor.idSensor
                        + "'" + " Publicado en la fecha: " + "'" + dato_sensor.fecha_hora + "'",
                        info_s: dato_sensor.informacion


                    });

                }
            }
        });

    },
    showFamilia: function (req, res) {//Listo
        console.log(req.body.codigo_familia);
        var query = Familia.findOne({ 'codigo_familia': req.body.codigo_familia });
        query.select('_id codigo_familia nombre nombre_cientifico');
        query.exec(function (err, familia) {
            if (familia == null) {
                res.json({ success: false, msg: 'No se encontró la familia' });
            }
            else {
                if (err) { res.json({ success: false, msg: 'no se pudo encontrar la familia' }); return handleError(err); }
                else {
                    res.json({
                        success: true, msg: "Familia encontrada con id: '" + familia.codigo_familia + "'" +
                        " nombre: '" + familia.nombre + "'" + " Nombre científico '" + familia.nombre_cientifico
                    });
                }
            }
        });
    },
    showEnfermedad: function (req, res) {//Listo
        var query = Enfermedad.findOne({ 'id_Enfermedad': req.body.id_Enfermedad });
        query.select('_id id_Enfermedad nombre ');
        query.exec(function (err, enfermedad) {
            if (enfermedad == null) {
                res.json({ success: false, msg: 'No se encontró la enfermedad' });
            }
            else {
                if (err) { res.json({ success: false, msg: 'no se pudo encontrar la enfermedad' }); return handleError(err); }
                else {
                    res.json({
                        success: true, msg: "Enfermedad encontrada con id: '" + enfermedad.id_Enfermedad + "'" +
                        " nombre: '" + enfermedad.nombre + "'"
                    });
                }
            }
        });
    },
    showSintoma: function (req, res) {//Listo
        var query = Sintoma.findOne({ 'id_sintoma': req.body.id_sintoma });
        query.select('_id id_sintoma nombre descripcion idPlanta idEnfermedad');
        query.exec(function (err, sintoma) {
            if (sintoma == null) {
                res.json({ success: false, msg: 'No se encontró la planta' });
            }
            else {
                if (err) { res.json({ success: false, msg: 'no se pudo encontrar la enfermedad' }); return handleError(err); }
                else {
                    Enfermedad.findOne({ 'id_Enfermedad': sintoma.idEnfermedad }, function (err, user) {
                        if (err) { res.json({ success: false, msg: 'no se pudo encontrar la enfermedad' }); return handleError(err); }
                        else {
                            Planta.findOne({ 'id_planta': sintoma.idPlanta }, function (err, user) {
                                if (err) { res.json({ success: false, msg: 'no se pudo encontrar la planta' }); return handleError(err); }
                                else {
                                    res.json({
                                        success: true, msg: 'Se encontró el síntoma con el id: ' + sintoma.id_sintoma
                                        + ' De la enfermedad ' + sintoma.idEnfermedad + ' Referenciado a la planta: ' + sintoma.idPlanta
                                    });

                                }
                            });


                        }
                    });
                }
            }
        });
    },
    showCondicionClimatica: function (req, res) {//Listo
        
        var query = Condicion_Climatica.findOne({ 'id_condicion' : req.body.id_condicion });
        
        query.select('_id id_condicion temperatura humedad humedad_relativa');
        query.exec(function (err, cond_c) {
            if (cond_c == null) {
                res.json({ success: false, msg: 'No se encontró la condicion climatica' });
            }
            else {
                if (err) { res.json({ success: false, msg: 'no se pudo encontrar la condicion climatica' }); return handleError(err); }
                else {
                    res.json({
                        success: true, msg: "Condicion Climatica encontrada con id: '" + cond_c.id_condicion + "'" +
                        "'" + " temperatura: " + "'" + cond_c.temperatura + "'"
                        + " humedad" + "'" + cond_c.humedad + "'" + " humedad relativa" + "'" + cond_c.humedad_relativa + "'"
                    });
                }
            }
        });
    },
    showVegetacion: function (req, res) {//Listo
        var query = Vegetacion.findOne({ 'id_vegetacion': req.params.id_vegetacion });
        query.select('_id id_vegetacion beneficios idPlanta idCondicionClimatica');
        query.exec(function (err, veget) {
            if (veget == null) {
                res.json({ success: false, msg: 'No se encontró la planta' });
            }
            else {
                if (err) { res.json({ success: false, msg: 'no se pudo encontrar la enfermedad' }); return handleError(err); }
                else {
                    Condicion_Climatica.findOne({ 'id_CondicionClimatica': veget.idCondicionClimatica }, function (err, user) {
                        if (err) { res.json({ success: false, msg: 'no se pudo encontrar la enfermedad' }); return handleError(err); }
                        else {
                            Planta.findOne({ 'id_planta': veget.idPlanta }, function (err, user) {
                                if (err) { res.json({ success: false, msg: 'no se pudo encontrar la planta' }); return handleError(err); }
                                else {
                                    res.json({
                                        success: true, msg: 'Se encontró el síntoma con el id: ' + veget.id_vegetacion
                                        + ' De la condicion climatica ' + veget.idCondicionClimatica + ' Referenciado a la planta: ' + veget.idPlanta
                                    });

                                }
                            });


                        }
                    });
                }
            }
        });
    },
    getPlantasP: function (req, res){
        Planta_Personal.find({'idUser':req.query.cedula},function(err, plantasp) {
             if (err)
                res.send(err)
                res.json({success:true, plantas:plantasp});
        });
    },
    getPlantas: function (req, res){
        Planta.find({},function(err, plantas) {
             if (err){
                res.send(err)}
                else
                res.json({success:true, plantas:plantas});
        });
    },
    
    
    
}

module.exports = query;