
//se definen las variables
var Planta = require('../models/planta');
var Sensor = require('../models/sensor');
var User = require('../models/user');
var Dato_Sensor = require('../models/dato_sensor');
var Planta_Personal = require('../models/planta_personal');
var Familia = require('../models/familia');
var Enfermedad = require('../models/enfermedad');
var Sintoma = require('../models/sintoma');
var Condicion_Climatica = require('../models/condicion_climatica');
var Vegetacion = require('../models/vegetacion');



var functions = {

    updateUser: function (req, res) {
        var query = { name: req.body.name };
        var update = {
            email: req.body.email, nombre1: req.body.nombre1, nombre2: req.body.nombre2,
            apellido1: req.body.apellido1, apellido2: req.body.apellido2
        };
        User.findOneAndUpdate(query, update, { new: true }, function (err, doc) {
            if (err) {
                console.log("Something wrong when updating data!");
                res.json({ success: false, msg: 'Error al actualizar' });
            }
            console.log(doc);
            res.json({ success: true, msg: 'Actualizado correctamente' });
        });
    },
    updatePlantaPersonal: function (req, res) {//Listo
        res.json({ success: true, msg: 'No se puede actualizar por que sólo posee el campo _id' });
    },
    updatePlanta: function (req, res) {//Listo
        var query = { id_planta: req.body.id_planta };
        var update = {
            nombre: req.body.nombre, nombreCient: req.body.nombreCient,
            tamaño: req.body.tamaño, idFamilia: req.body.idFamilia
        };
        Familia.findOne({ 'codigo_familia': req.body.idFamilia }, function (err, familia) {
            if (err) {
                res.json({ success: false, msg: 'Error desconocido, la planta no existe' });
                return handleError(err);
            }
            else {
                if (familia != null) {
                    Planta.findOneAndUpdate(query, update, { new: true }, function (err, doc) {
                        if (err) {
                            res.json({ success: false, msg: 'Error al actualizar' });
                        }
                        console.log(doc);
                        res.json({ success: true, msg: 'Actualizado correctamente' });
                    });
                }
                else {
                    res.json({ success: false, msg: 'Verifica los campos' });
                }
            }
        });
    },
    updateFamilia: function (req, res) {//Listo
        var query = { codigo_familia: req.body.codigo_familia };
        var update = { nombre: req.body.nombre, nombre_cientifico: req.body.nombre_cientifico };
        Familia.findOne({ 'codigo_familia': req.body.codigo_familia }, function (err, docs) {
            if (docs != null) {
                Familia.findOneAndUpdate(query, update, { new: true }, function (err, doc) {
                    if (err) {
                        res.json({ success: false, msg: 'Error al actualizar' });
                    }
                    res.json({ success: true, msg: 'Actualizado correctamente' });
                });
            }
            else {
                res.json({ success: false, msg: 'No existe la familia' });
            }
        });

    },
    updateCondicionClimatica: function (req, res) {
        var query = { id_condicion: req.body.id_condicion };
        var update = {
            temperatura: req.body.temperatura, humedad: req.body.humedad,
            humedad_relativa: req.body.humedad_relativa
        };
        Condicion_Climatica.findOne({ 'id_condicion': req.body.id_condicion }, function (err, docs) {
            if (docs.length) {

                Condicion_Climatica.findOneAndUpdate(query, update, { new: true }, function (err, doc) {
                    if (err) {
                        res.json({ success: false, msg: 'Error al actualizar' });
                    } else {
                        res.json({ success: true, msg: 'Actualizado correctamente' });
                    }
                });
            } else {
                res.json({ success: false, msg: 'La condicion climatica no existe' });

            }
        });
    },
    updateDatoSensor: function (req, res) {//Listo Verificar jerarquia
        var query = { codigo_dato: req.body.codigo_dato };
        var update = { informacion: req.body.informacion };
        Dato_Sensor.find({ 'codigo_dato': req.body.codigo_dato }, function (err, docs) {
            if (docs.length) {
                Dato_Sensor.findOneAndUpdate(query, update, { new: true }, function (err, doc) {
                    if (err) {
                        res.json({ success: false, msg: 'Error al actualizar' });
                    }
                    res.json({ success: true, msg: 'Actualizado correctamente' });
                    console.log(doc);
                });
            }
            else {
                res.json({ success: false, msg: 'El dato del sensor no existe' });

            }
        });

    },
    updateSensor: function (req, res) {//Listo verificar jerarquia
        var query = { codigo_sensor: req.body.codigo_sensor };
        var update = { idPlanta_Personal: req.body.posicion_planta, nombre: req.body.nombre };

        Planta_Personal.findOne({ 'posicion_planta': req.body.posicion_planta }, function (err, planta_p) {
            if (err) {
                res.json({ success: false, msg: 'Error desconocido, la planta no existe' });
                return handleError(err);
            }
            else {
                if (planta_p != null) {
                    Sensor.findOneAndUpdate(query, update, { new: true }, function (err, doc) {
                        if (err) {
                            res.json({ success: false, msg: 'Error al actualizar' });
                        }
                        res.json({ success: true, msg: 'Actualizado correctamente' });
                    });
                }
                else {
                    res.json({ success: false, msg: 'Verifica los campos' });
                }
            }
        });
    },
    updateEnfermedad: function (req, res) {//Listo
        var query = { id_Enfermedad: req.body.id_Enfermedad };
        var update = { nombre: req.body.nombre };

        Enfermedad.findOne({ 'id_Enfermedad': req.body.id_Enfermedad }, function (err, docs) {
            if (docs != null) {
                Enfermedad.findOneAndUpdate(query, update, { new: true }, function (err, doc) {
                    if (err) {
                        res.json({ success: false, msg: 'Error al actualizar' });
                    }
                    res.json({ success: true, msg: 'Actualizado correctamente' });
                });
            }
            else {
                res.json({ success: false, msg: 'La enfermedad no existe' });

            }
        });

    },
    updateSintoma: function (req, res) {//Listo verificar jerarquia
        var query = { id_sintoma: req.body.id_sintoma };
        var update = {
            nombre: req.body.nombre, descripcion: req.body.descripcion,
            idPlanta: req.body.idPlanta, idEnfermedad: req.body.idEnfermedad
        };
        Sintoma.findOne({ 'id_sintoma': req.body.id_sintoma }, function (err, docs) {

            if (docs != null) {
                Sintoma.findOneAndUpdate(query, update, { new: true }, function (err, doc) {
                    if (err) {
                        res.json({ success: false, msg: 'Error al actualizar' });
                    }
                    res.json({ success: true, msg: 'Actualizado correctamente' });
                });

            } else {
                res.json({ success: false, msg: 'El sintoma no existe' });

            }
        });
    },
    updateVegetacion: function (req, res) {//Listo verificar jerarqías
        var query = { id_vegetacion: req.body.id_vegetacion };
        var update = {
            beneficios: req.body.beneficios, idPlanta: req.body.idPlanta,
            idCondicionClimatica: req.body.idCondicionClimatica,
        };
        Vegetacion.findOne({ 'id_vegetacion': req.body.id_vegetacion }, function (err, docs) {
            if (docs != null) {

                Vegetacion.findOneAndUpdate(query, update, { new: true }, function (err, doc) {
                    if (err) {
                        res.json({ success: false, msg: 'Error al actualizar' });
                    }
                    res.json({ success: true, msg: 'Actualizado correctamente' });
                });
            } else {
                res.json({ success: false, msg: 'La vegetacion no existe' });
            }
        });

    },
}
module.exports = functions;