//Se definnen las variables

var Planta = require('../models/planta');
var Planta_Personal = require('../models/planta_personal');
var mongoose = require('mongoose');
var Schema = mongoose.Schema;//se usa Schema para definir el modelamiento de datos
var bcrypt = require('bcryptjs');//se usa bcrypt para encriptar la contraseña
var shortid = require('shortid');


//modela la entidad usuario con nombre y contraseña, se definen los tipos y si son requeridos
var userSchema = new Schema({
   _id:{
       type: String,
       default: shortid.generate
   },
   _cedula: {
       type: String,
   },
    name: {
    type: String,
    required: true
    },
    password: {
        type: String,
        required: true
    },
    nombre1: {
        type: String,
        //required: true
    },
    nombre2: {
        type: String,
        //required: true
    },
    apellido1:{
        type: String,
        //required: true
    },
    apellido2:{
        type :String,
        //required: true
    },
    phone: {
        type: String,
        required: false
    },
    email: {
        type: String,
        required: false
    },
    

});



userSchema.pre('save', function (next) {
    var user = this;
    if (this.isModified('password') || this.isNew) {
        bcrypt.genSalt(10, function (err, salt) {
            if (err) {
                return next(err);
            }
            bcrypt.hash(user.password, salt, function (err, hash) {
                //utiliza hash para codificar la contraseña
                if (err) {
                    return next(err);
                }
                user.password = hash;
                next();
            });
        });
    } else {
        return next();
    }
});

userSchema.methods.comparePassword = function (passw, cb) {
    bcrypt.compare(passw, this.password, function (err, isMatch) {
        if (err) {
            return cb(err);
        }
        cb(null, isMatch);
    });
};

module.exports = mongoose.model('User', userSchema);