//Importa dependencias
var mongoose = require('mongoose');
    express = require('express');
    cors = require('cors');
    morgan = require('morgan');
    config = require('./config/database');
    passport = require('passport');
    routerPost = require('./routes/routerPost');
    routerGet =require('./routes/routerGet');
    routerUpdate = require('./routes/routerUpdate');
    routerDelete = require('./routes/routerDelete');
    bodyParser = require('body-parser');
    shortid = require('shortid');
    
//Mongoose se conecta a el archivo database definida en el fichero config
mongoose.connect(config.database);

//Cuando se conecte realiza lo que está adentro de la función
mongoose.connection.on('open', function(){
    console.log('Mongo está conectado');
    //el servidor sólo correra si hay una conexión a la base de datos
    var app = express();
    
    app.use(morgan('dev'));
    app.use(cors());
    app.use(bodyParser.urlencoded({extended: false}));
    app.use(bodyParser.json());
    app.use(routerPost);
    app.use(routerGet);
    app.use(routerUpdate);
    app.use(routerDelete);
    app.use(shortid);
    app.use(passport.initialize());
    
    require('./config/passport')(passport);
    
    //se inicaliza el servidor en el puerto 3333
    app.listen(process.env.PORT, function(){
      // app.listen(3333, function(){
        console.log('El servidor está conectado en el puerto 3333');
    })
})

